\chapter{Implementation part}

During the implementation, we first identified possible inputs of the `cryptsetup` program and possible attack vectors. We created a Docker image with all the libraries `cryptsetup` depends on, built statically. We implemented nonintelligent fuzz targets and prepared a fuzzing dictionary and a seed corpus. Because the LUKS2 format is more structured, as it uses JSON internally, it is harder to fuzz using off-the-shelf fuzzers. Thus we introduced a more advanced fuzz target based on a custom mutator explicitly designed for the LUKS2 format. Finally, we ran the fuzzer for an extended period and analysed discovered crashing inputs. The discovered bugs have been reported and fixed in the upstream `cryptsetup` issue tracker and fixed.

# Attack surface and threat analysis

In the beginning, we analysed the `cryptsetup` codebase \cite{cryptsetup} to identify places where external input is processed and can serve as a potential attack vector. The three primary input sources are structures passed between the Linux kernel and `cryptsetup`, the command line parameters passed by the user, and finally, the on-disk metadata. Although it is reasonable to fuzz kernel structures and command line parameters to detect reliability issues, potential problems in these components pose no additional security risk. The reason is that the kernel is already implicitly trusted to provide the userspace execution environment for `cryptsetup`. We do not consider bugs in the parsing of command-line parameters a significant security issue, as only the user himself can specify them, so he can gain no additional privileges.

The riskiest input is the on-disk metadata. The LUKS2 format only contains the SHA256 hash of the header to detect accidental corruption, but it does not guarantee protection against intentional attacks \cite{luks2}. Therefore if there is a bug in metadata handling code, the attacker who has write-access to the metadata can trigger it. This scenario can be especially dangerous since the `cryptsetup` utility usually runs under the superuser account. Worse still, most popular distributions use `udisks` daemon \cite{udisks} to automatically scan and attempt to activate any newly connected device \cite{automount}. Plugging a USB drive with a maliciously crafted LUKS2 header would be enough to compromise the system and obtain `root` privileges. Otherwise, an offline attack on the encrypted metadata can be performed, known as an _evil maid attack_ \cite{evil_maid}. Therefore, we have decided to focus on fuzzing the metadata processing code.

# Fuzz target building

We first need to prepare the building environment for compilation of `cryptsetup` and fuzz targets. The _builder_ Docker image, used by OSS-Fuzz, is based on Ubuntu 20.04 \cite{ubuntu20}. We need to install all dependencies `cryptsetup` requires and link them statically because they won't be available in the _runner_ image used for fuzz target execution.

To compile the fuzz targets with a memory sanitiser, we also must compile all of its dependencies with a memory sanitiser. We can not link to libraries provided by the package manager because they are compiled in a release mode. Therefore, we must manually compile all the dependencies from the source code. Another advantage of building dependencies from source code is that the OSS-Fuzz compiler options are used, including coverage sanitiser, so coverage feedback will also be gathered from the libraries' code, not only from the `cryptsetup` program. Therefore the fuzzer can find more interesting test cases.

Another problem that needs to be addressed during compilation is whether to calculate the checksum or disable it altogether for fuzzing. OSS-Fuzz defines a constant \footnote{\texttt{FUZZING\_BUILD\_MODE\_UNSAFE\_FOR\_PRODUCTION}} which can be used to disable the compilation of checksum calculation and verification code conditionally. Disabling

checksums can speed up fuzzing, but it can increase the danger of misconfiguration and disabling integrity protection in the release version of `cryptsetup`. For similar reasons, `cryptsetup` does not support debug build out-of-the-box. When the checksum verification is disabled entirely, `cryptsetup` will always use the primary header. Therefore it becomes impossible to generate scenarios where different combinations of valid and invalid checksums for primary and secondary headers are present.

Another option is to create a mock cryptography backend that always returns the same hash result (e.g. all zeroes). This way, it is possible to select if a particular header shall pass the checksum verification (e.g. when the checksum is all zeroes, the header will pass the check otherwise, it will not). However, replacing the checksum implementation can also influence other parts of the code where checksums are used. Therefore, we have chosen to automatically calculate the correct checksum for every generated LUKS2 header and insert it into the generated metadata.

# Nonintelligent fuzzing

To implement a fuzz target, we need to export a function called \linebreak `LLVMFuzzerTestOneInput`, which takes an input buffer and its length and passes the data to the program under test. We need to identify functions that take the input and perform some potentially vulnerable operations on it. We have identified the functions `crypt_init` and`crypt_load`. The `crypt_init` function initialises the context with the specified filename. The `crypt_load` function is responsible for detecting the file format, parsing and validating the device or file.

Loading from memory image is not supported by the API provided in `libcryptsetup`, so we need to write the buffer passed from the fuzzing engine to a temporary file. Before writing to the file, we zero out the checksum location in the in-memory header, calculate the checksum and write it to the erased location. When the buffer is written to a file, we allocate 20MiB by creating a sparse file. Therefore we decrease the risk that the `libcryptsetup` will exit prematurely because the image is too small.

To help the fuzzer discover interesting test cases more quickly, we have produced a fuzzing dictionary for the LUKS2 format. The dictionary is based on an AFL JSON dictionary \cite{afl_json_dict}, with added keywords from the LUKS2 specification \cite{luks2}. As can be seen in \autoref{fuzzing-dictionary}, we have included the binary magic values for primary and secondary headers as well as various strings used in the JSON area.

To provide the fuzzer with a good starting point, we have collected various LUKS2 images to form the seed corpus. The fuzzer will then mutate and combine portions of the images to form new ones. The images have been collected from the current `cryptsetup` test suite, which can generate many valid and invalid images for testing. The following section will propose a more intelligent image fuzzer and generator. The images from the structured fuzzer can be converted and added to the seed corpus of the nonintelligent fuzzer to increase the code coverage further.

# Structured fuzzing

While the efficiency of fuzzers greatly improved with the introduction of coverage feedback, they still perform relatively low-level modifications like bit flipping, byte swapping or removal. This process often generates severely malformed inputs, which are easily detected and filtered out by the program under test. This is especially true for programs that consume highly-structured data \cite{structured_fuzzing}. Making a change in structured formats often requires a symmetrical change in a different location (e.g. adding an opening brace in a C source code requires adding a closing brace at the end of the code block). This is also the case with the LUKS2 format, which internally uses a structured JSON format.

To discover bugs in higher levels of abstraction than the parser, we need to teach the fuzzer how to generate semi-valid inputs of the given format. For example, in the case of a C compiler, we want to perform the fuzzing on an abstract syntax tree (AST) rather than on the ASCII text of the source code. We need to reimplement the built-in generic mutation and crossover functions with format-specific ones.

We will describe the process for the `libfuzzer` engine. Firstly, we need to specify a fuzz target same as for a nonintelligent fuzzer (by defining the `LLVMFuzzerTestOneInput` function). To implement the custom mutator, we need to define an `LLVMFuzzerCustomMutator` function \cite{structured_doc}. This function is called with the input data, input data size, the maximum size after mutation and the seed for a random number generator as an argument. It must parse the data, perform the mutation, serialise the data structure back into the buffer and return the size after mutation (which must not exceed the maximum size). If the custom mutator can not parse the data, a trivial input case (e.g. a program with just the main function) should be returned.

The custom mutator implementation may need to obtain some intelligently chosen data to fill into the data structure during the mutation (e.g. a function name in a C source code). The `libfuzzer` engine provides a function `LLVMFuzzerMutate`, which takes a buffer and mutates it in place. This function takes the buffer, size, and maximum size after mutation and returns the size after mutation.

The custom mutator can assume that the mutation performed by `LLVMFuzzerMutate` is done intelligently, which means the input is chosen to maximise code coverage. The `libfuzzer` engine can repeatedly call the custom mutator on the same data structure and let the `LLVMFuzzerMutate` perform different mutations until an interesting case is found. The custom mutator can also implement the `LLVMFuzzerCustomCrossOver` function, which takes two inputs, combines them and produces a single output.

While this API provides everything necessary for the custom mutator implementation, it is still relatively low-level and inconvenient for the developer. To address this problem, a `libprotobuf-mutator` library was developed \cite{libprotobuf-mutator}. It is based on the Protocol Buffer (shortly `protobuf`) technology.

The `protobuf` provides a way to describe structured data using a `.proto` file with special syntax. A specialised `protoc` compiler parses this description and automatically generates C++ source code files that represent the described data structure and implement basic operations \cite{protobuf}. The `protobuf` supports elementary types, including integers, booleans, enums, floating-point numbers and strings \cite{protobuf_lang}. It also supports composite types (called _message_s) consisting of other messages or elementary types. Every field in a message can be _required_, _optional_ or _repeated_.

When the C++ source files for the `.proto` file are generated, we can use `libprotobuf-mutator` to automatically define a `libfuzzer` custom mutator for the described data structure. The custom mutator implementation can be generated using the provided macro `DEFINE_PROTO_FUZZER`. The developer then needs to implement a function that takes the generated `protobuf` object, converts it to the fuzzed format and passes it to the program under test \cite{structured_fuzzing}.

The main advantage is the simplicity of use compared to the native API, but there are also multiple disadvantages. The first disadvantage is that the developer must describe the format using `protobuf` and implement an additional converter from `protobuf` to the fuzzed format. However, the time spent writing the converter and `.proto` file is usually shorter than writing a custom mutator using a native API. The next disadvantage is that the corpus generated by the fuzzer consists of `protobuf` objects, not the target file format inputs. Therefore, it cannot be used with nonintelligent fuzzers without conversion, but since the developer needs to implement a converter anyway, it can also convert the corpus. The last disadvantage is that not all formats can be easily described using `protobuf`. For example, mutating C source code is easier on the AST than on a `protobuf`.

After the evaluation, we have decided to implement the custom mutator for LUKS2 using `protobuf` as the advantages outweigh the disadvantages.

In the first step, we had to analyse the LUKS2 format by reading the specification \cite{luks2}. Then we described the format using `protobuf` as shown in \autoref{luks2-proto}. The fuzzer is defined on the `LUKS2_both_headers` object, containing two binary headers, JSON area description and `seqid` description. Instead of directly fuzzing `seqid` integers, we have decided to allow only three scenarios: primary header `seqid` is greater, secondary header `seqid` is greater and equal `seqid` for both headers. We have made this optimisation because there are below ten lines of code dealing with `seqid`, which only compare the primary and secondary header's `seqid`.

The `LUKS2_header` message describes a single binary header. It contains fields specifying the version, magic value, header size, and whether to use a correct checksum and offset. Only sizes allowed by the LUKS2 specification can be used. We have decided to limit the size to 64KiB to speed up fuzzing, as a checksum needs to be calculated for the whole header.

In the LUKS2 JSON area, every object is indexed by an integer and can reference other objects by their ID (e.g. digest object contains an array of associated segments and keyslots). We have limited the ID integer to a range from -16 to 16 to allow easier cross-reference generation. Places, where a `string-uint64` is expected are represented by a message containing either an arbitrary string or an unsigned integer, optionally prefixed by a minus sign.

For the protobuf to LUKS2 image conversion, we use a binary header structure definition taken from the `cryptsetup` utility code. We use the `json-c` library \cite{json-c} for constructing the JSON area. We have chosen this library because the `cryptsetup` utility also uses it and is readily available in the _builder_ Docker image. We use the `cryptsetup` cryptographic backend for the checksum calculation.

We have integrated fuzz targets building into the `cryptsetup` build system based on Autoconf \cite{autoconf}, and Automake \cite{automake}. The build system automatically detects the correct compiler and linker flags for `libprotobuf-mutator` and `protobuf` libraries. Fuzz targets are automatically linked to the fuzzing engine specified by the environment variable `LIB_FUZZING_ENGINE` (as required by OSS-Fuzz). If the variable is not defined, the `libfuzzer` engine is used by default. Therefore, the user can build the fuzz targets outside the Docker image and OSS-Fuzz infrastructure.

# Adding fuzzing to the Continuous Integration pipeline

OSS-Fuzz project out-of-the-box supports running the project fuzz targets in its Continuous Integration (CI) pipeline. The CI fuzz job can run on every commit and pull request. Therefore, the fuzzer can catch the bugs before merging them into the repository. The CI support is provided by CIFuzz Github action \cite{cifuzz,github-actions}.

It works by building the fuzz targets from the specific commit from the pull request. The fuzz target is run in the CI with a time limit. The default time limit, which the developer can override, is 10 minutes. If the fuzz target triggers a crash during this period, the GitHub action fails and shows a red mark. The stack trace and reproducer can be downloaded from the action's artifacts.

The CIFuzz automatically downloads and uses the corpus generated by OSS-Fuzz. It also adds reproducers for bugs discovered in the past 30 days. Thus, regressions are quickly detected before they are merged.

The crucial disadvantage is that this approach only works with repositories hosted on GitHub, which is not the case of `cryptsetup`, which s hosted on GitLab. However, the code for CIFuzz GitHub actions is available in the OSS-Fuzz project \cite{oss-fuzz-github}, so we can reimplement them for GitLab CI. Inspiration can be drawn from the Wireshark project, which is also hosted on GitLab \cite{wireshark}. This project contains custom jobs that build and run the fuzz targets for a limited period.

# Evaluation

After implementing the fuzz targets and Dockerfile describing the environment and dependencies, we have run the fuzzer locally on a 48 core machine. We have used the OSS-Fuzz infrastructure scripts \cite{oss-fuzz-github} to automate the fuzz target building, running and Docker container creation. Both intelligent and nonintelligent LUKS2 fuzz targets have been running for one week on the machine.

We have firstly run the structure-aware fuzzer with an empty seed corpus. However, we detected no crashes during the week. Moreover, the code coverage stopped growing after approximately two days, meaning that most of the validator code reachable from the `crypt_load` function was covered without bugs.

Even though the structure-aware fuzz target found no bugs, it generated a large corpus of interesting LUKS2 `protobuf` objects. We used the previously implemented `protobuf` to LUKS2 image converter to convert the objects to raw LUKS2 images. Then, we used them as a seed corpus for the nonintelligent fuzzer. This seed corpus provided approximately four times higher initial code coverage than a seed corpus consisting of just images collected from the test suite.

All discovered bugs were reported to the `cryptsetup` issue tracker on Gitlab \cite{cryptsetup_issues} and all the merge requests \cite{cryptsetup_mr} with fixes for the bugs have been merged. The nonintelligent fuzz target quickly discovered an out-of-bounds memory allocation caused by not properly checking the header. The `hdr_size` field of the binary header was directly passed to the memory allocation function before any check was made. Under some circumstances, the bug can lead to a denial of service.

The next discovered bug was an off-by-one write caught by the sanitiser. The bug was in a logging function which converted a binary checksum to hexadecimal and printed it. The code was supposed to assign a trailing zero at the end of the hexadecimal string but erroneously wrote it one byte after the end of the buffer.

The final class of discovered bugs was missing JSON object type checking. The attacker can, for example, put an integer where an array is expected. An array access function is then used on the retrieved integer object, leading to an assertion failure inside the array access function. In some instances where the assertion is not present in the library code, this can lead to a `NULL`-dereference bug. Although this bug does not lead to code execution, it can still cause a crash of the `cryptsetup` utility or any other daemon (like `udisks`) that uses the `libcryptsetup` library for parsing encrypted volumes. Therefore we can classify this bug class as a denial of service. It is interesting to note that such bugs could not have been discovered using the structure-aware fuzzer because it obeys the basic structure of the JSON metadata.

The overview of discovered bugs and the associated issues and merge requests is shown on \autoref{fig:gl_table}. The issue and merge request IDs refer to the entries in the issue tracker \cite{cryptsetup_issues} and the list of merge requests \cite{cryptsetup_mr} of the `cryptsetup` project.

\input{figures/gitlab_table.tex}

In \autoref{lst:json_tokens}, we can see an example of generated metadata, where the fuzzer replaced the `tokens` object with an integer _43_. \autoref{lst:json_keyslots} shows a `keyslots` object replaced by an array and \autoref{lst:json_kdf} shows a keyslot object with an integer-string `kdf` instead of an object. All of the examples were generated by the previously described process.

\input{figures/tokens.tex}

\input{figures/keyslots.tex}

\input{figures/kdf.tex}
